PROGRAM Turmiteninterpreter;
  {simuliert zellulren Automaten}

  USES
    Crt, Graph;

  CONST
    maxFarbenzahl = 14;
    genCode : string[maxFarbenzahl] = 'RRRLRRLLLLRLLN';

  TYPE
    tRichtung = (ost, nord, west, sued);
    tPunkt    = RECORD x, y: integer END;
    tZustand  = RECORD
                  position : tPunkt;
                  richtung : tRichtung
                END;

  VAR
    xsMax, ysMax : integer;
    zustand      : tZustand;

  PROCEDURE GrafikStart;
    VAR
      g0, g1 : integer;
    BEGIN
      g0 := detect; initGraph(g0, g1, 'BGI');
      xsMax := getMaxX; ysMax := getMaxY
    END; {of GrafikStart}

  PROCEDURE Anfangsbedingungen;
    VAR
      mitte : tPunkt;

    PROCEDURE horizontale (anzahl, schritt, farbNr: integer);
      VAR
        i : integer;
      BEGIN
        FOR i := 0 TO anzahl DO
          WITH zustand DO BEGIN
            inc(position.x, schritt);
            putPixel(position.x, position.y, farbNr)
          END {of with}
      END; {of Horizontale}

    BEGIN {Anfangsbedingungen}
      mitte.x := xsMax DIV 2;
      mitte.y := ysMax DIV 2;
      WITH zustand DO BEGIN
        position := mitte; richtung := ost;
        dec(position.x, 250);
        horizontale(50, 3, maxFarbenzahl - 1);
        horizontale(81, 1, maxFarbenzahl - 1)
      END {of with}
    END; {of Anfangsbedingungen}

  PROCEDURE rechts;
    BEGIN
      WITH zustand DO
        IF richtung = ost THEN
          richtung := sued
        ELSE
          richtung := pred(richtung)
    END; {of rechts}

   PROCEDURE links;
     BEGIN
       WITH zustand DO
         IF richtung = sued THEN
           richtung := ost
         ELSE
           richtung := succ(richtung)
     END; {of links}

   PROCEDURE vorwaerts;
     BEGIN
       WITH zustand DO
         CASE richtung OF
           ost  : inc(position.x);
           nord : dec(position.y);
           west : dec(position.x);
           sued : inc(position.y)
         END {of case}
     END; {of links}

   FUNCTION naechste (f: integer): integer;
     BEGIN
       IF f < maxFarbenzahl - 1 THEN
         naechste := (f + 1) MOD (maxFarbenzahl - 1)
       ELSE
         naechste := maxFarbenzahl - 1;
     END; {of naechste}

   PROCEDURE Interpretation;
    VAR
      farbNr : integer;
    BEGIN
      REPEAT
        WITH zustand DO BEGIN
          IF position.x <= 0 THEN position.x := xsMax - 1;
          IF xsMax <= position.x THEN position.x := 1;
          IF position.y <= 0 THEN position.y := ysMax - 1;
          IF ysMax <= position.y THEN position.y := 1;
          farbNr := getPixel(position.x, position.y);
          farbNr := naechste(farbNr);
          CASE genCode[farbNr + 1] OF
            'R' : BEGIN
                    putPixel(position.x, position.y, farbNr);
                    rechts; vorwaerts
                  END;
            'L' : BEGIN
                    putPixel(position.x, position.y, farbNr);
                    links; vorwaerts
                  END;
            'N' : vorwaerts
          END {of case}
        END {of with}
      UNTIL keypressed
    END; {of Interpretation}

  BEGIN {Hauptprogramm}
    GrafikStart;
    Anfangsbedingungen;
    Interpretation;
    closeGraph
  END.
